#!/bin/sh
#
# stop all daemons with open fd on /var/log
#

echo "\

  To unmount the sdcard-overlay we must stop all daemons with an open
  file descriptor on /var/log. This is only possible when shutting down
  those daemons. Hence this script does a lot more than unmounting the
  overlay!
"

echo "\
  Stop ds485d, ds485p, dsa, dss, dss11-ledd, lighttpd, mailq, pagekite
  rrdcached, upnpbeacon, dss11-buttond, dss11-websetup, runit, syslog
"

echo -n "Continue? y/N "
read answer

if [ -z "$answer" -o "$answer" != 'y' ]; then
    echo "exit..."
    exit
fi

do_daemons()
{
  action=$1
  [ -n $action -a \( $action == start -o $action == stop \) ] || {
    fail "do_daemons: invalid action $action"
  }
  for d in ds485d ds485p dsa dss dss11-ledd lighttpd mailq pagekite \
      rrdcached upnpbeacon; do
    if [ -n "$UNITTEST" ]; then
      #echo sv $action $d
      continue
    fi
    sv $action $d
  done

  # atd avahi-daemon crond dbus-1 dropbear
  for d in dss11-buttond dss11-websetup runit.sh syslog; do
    if [ -n "$UNITTEST" ]; then
      #echo /etc/init.d/$d $action
      continue
    fi
    /etc/init.d/$d $action
  done
}


do_daemons stop

# random timeout to wait till daemons are dead
sleep 5

umount /var/log
umount /usr/share/dss/data/metering
umount /media/card

# do_daemons start

echo "\

  Don't forgert to RESTART those deamons when done
  Or simply reboot the system when unsure

"
